diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
index 141c45dc27..87ff8041aa 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -153,12 +153,12 @@ static const struct among a_5[24] =
 /*  0 */ { 4, s_5_0, -1, 3, 0},
 /*  1 */ { 4, s_5_1, -1, 2, 0},
 /*  2 */ { 3, s_5_2, -1, 13, 0},
-/*  3 */ { 2, s_5_3, -1, 16, 0},
+/*  3 */ { 2, s_5_3, -1, 15, 0},
 /*  4 */ { 3, s_5_4, 3, 12, 0},
 /*  5 */ { 4, s_5_5, 4, 4, 0},
 /*  6 */ { 4, s_5_6, 3, 8, 0},
-/*  7 */ { 5, s_5_7, 3, 14, 0},
-/*  8 */ { 6, s_5_8, 3, 15, 0},
+/*  7 */ { 5, s_5_7, 3, 9, 0},
+/*  8 */ { 6, s_5_8, 3, 14, 0},
 /*  9 */ { 5, s_5_9, 3, 10, 0},
 /* 10 */ { 5, s_5_10, 3, 5, 0},
 /* 11 */ { 5, s_5_11, -1, 8, 0},
@@ -317,62 +317,52 @@ static const unsigned char g_v_WXY[] = { 1, 17, 65, 208, 1 };
 
 static const unsigned char g_valid_LI[] = { 55, 141, 2 };
 
-static const symbol s_0[] = { '\'' };
-static const symbol s_1[] = { 'y' };
-static const symbol s_2[] = { 'Y' };
-static const symbol s_3[] = { 'y' };
-static const symbol s_4[] = { 'Y' };
-static const symbol s_5[] = { 's', 's' };
-static const symbol s_6[] = { 'i' };
-static const symbol s_7[] = { 'i', 'e' };
-static const symbol s_8[] = { 'e', 'e' };
-static const symbol s_9[] = { 'e' };
-static const symbol s_10[] = { 'e' };
-static const symbol s_11[] = { 'y' };
-static const symbol s_12[] = { 'Y' };
-static const symbol s_13[] = { 'i' };
-static const symbol s_14[] = { 't', 'i', 'o', 'n' };
-static const symbol s_15[] = { 'e', 'n', 'c', 'e' };
-static const symbol s_16[] = { 'a', 'n', 'c', 'e' };
-static const symbol s_17[] = { 'a', 'b', 'l', 'e' };
-static const symbol s_18[] = { 'e', 'n', 't' };
-static const symbol s_19[] = { 'i', 'z', 'e' };
-static const symbol s_20[] = { 'a', 't', 'e' };
-static const symbol s_21[] = { 'a', 'l' };
-static const symbol s_22[] = { 'f', 'u', 'l' };
-static const symbol s_23[] = { 'o', 'u', 's' };
-static const symbol s_24[] = { 'i', 'v', 'e' };
-static const symbol s_25[] = { 'b', 'l', 'e' };
-static const symbol s_26[] = { 'l' };
-static const symbol s_27[] = { 'o', 'g' };
-static const symbol s_28[] = { 'f', 'u', 'l' };
-static const symbol s_29[] = { 'l', 'e', 's', 's' };
-static const symbol s_30[] = { 't', 'i', 'o', 'n' };
-static const symbol s_31[] = { 'a', 't', 'e' };
-static const symbol s_32[] = { 'a', 'l' };
-static const symbol s_33[] = { 'i', 'c' };
-static const symbol s_34[] = { 's' };
-static const symbol s_35[] = { 't' };
-static const symbol s_36[] = { 'l' };
-static const symbol s_37[] = { 's', 'k', 'i' };
-static const symbol s_38[] = { 's', 'k', 'y' };
-static const symbol s_39[] = { 'd', 'i', 'e' };
-static const symbol s_40[] = { 'l', 'i', 'e' };
-static const symbol s_41[] = { 't', 'i', 'e' };
-static const symbol s_42[] = { 'i', 'd', 'l' };
-static const symbol s_43[] = { 'g', 'e', 'n', 't', 'l' };
-static const symbol s_44[] = { 'u', 'g', 'l', 'i' };
-static const symbol s_45[] = { 'e', 'a', 'r', 'l', 'i' };
-static const symbol s_46[] = { 'o', 'n', 'l', 'i' };
-static const symbol s_47[] = { 's', 'i', 'n', 'g', 'l' };
-static const symbol s_48[] = { 'Y' };
-static const symbol s_49[] = { 'y' };
+static const symbol s_0[] = { 'Y' };
+static const symbol s_1[] = { 'Y' };
+static const symbol s_2[] = { 's', 's' };
+static const symbol s_3[] = { 'i' };
+static const symbol s_4[] = { 'i', 'e' };
+static const symbol s_5[] = { 'e', 'e' };
+static const symbol s_6[] = { 'e' };
+static const symbol s_7[] = { 'e' };
+static const symbol s_8[] = { 'i' };
+static const symbol s_9[] = { 't', 'i', 'o', 'n' };
+static const symbol s_10[] = { 'e', 'n', 'c', 'e' };
+static const symbol s_11[] = { 'a', 'n', 'c', 'e' };
+static const symbol s_12[] = { 'a', 'b', 'l', 'e' };
+static const symbol s_13[] = { 'e', 'n', 't' };
+static const symbol s_14[] = { 'i', 'z', 'e' };
+static const symbol s_15[] = { 'a', 't', 'e' };
+static const symbol s_16[] = { 'a', 'l' };
+static const symbol s_17[] = { 'f', 'u', 'l' };
+static const symbol s_18[] = { 'o', 'u', 's' };
+static const symbol s_19[] = { 'i', 'v', 'e' };
+static const symbol s_20[] = { 'b', 'l', 'e' };
+static const symbol s_21[] = { 'o', 'g' };
+static const symbol s_22[] = { 'l', 'e', 's', 's' };
+static const symbol s_23[] = { 't', 'i', 'o', 'n' };
+static const symbol s_24[] = { 'a', 't', 'e' };
+static const symbol s_25[] = { 'a', 'l' };
+static const symbol s_26[] = { 'i', 'c' };
+static const symbol s_27[] = { 's', 'k', 'i' };
+static const symbol s_28[] = { 's', 'k', 'y' };
+static const symbol s_29[] = { 'd', 'i', 'e' };
+static const symbol s_30[] = { 'l', 'i', 'e' };
+static const symbol s_31[] = { 't', 'i', 'e' };
+static const symbol s_32[] = { 'i', 'd', 'l' };
+static const symbol s_33[] = { 'g', 'e', 'n', 't', 'l' };
+static const symbol s_34[] = { 'u', 'g', 'l', 'i' };
+static const symbol s_35[] = { 'e', 'a', 'r', 'l', 'i' };
+static const symbol s_36[] = { 'o', 'n', 'l', 'i' };
+static const symbol s_37[] = { 's', 'i', 'n', 'g', 'l' };
+static const symbol s_38[] = { 'y' };
 
-static int r_prelude(struct SN_env * z) {
+static int r_prelude(struct SN_env * z) { /* forwardmode */
     z->B[0] = 0; /* unset Y_found, line 26 */
     {   int c1 = z->c; /* do, line 27 */
         z->bra = z->c; /* [, line 27 */
-        if (!(eq_s(z, 1, s_0))) goto lab0;
+        if (z->c == z->l || z->p[z->c] != '\'') goto lab0; /* literal, line 27 */
+        z->c++;
         z->ket = z->c; /* ], line 27 */
         {   int ret = slice_del(z); /* delete, line 27 */
             if (ret < 0) return ret;
@@ -382,9 +372,10 @@ static int r_prelude(struct SN_env * z) {
     }
     {   int c2 = z->c; /* do, line 28 */
         z->bra = z->c; /* [, line 28 */
-        if (!(eq_s(z, 1, s_1))) goto lab1;
+        if (z->c == z->l || z->p[z->c] != 'y') goto lab1; /* literal, line 28 */
+        z->c++;
         z->ket = z->c; /* ], line 28 */
-        {   int ret = slice_from_s(z, 1, s_2); /* <-, line 28 */
+        {   int ret = slice_from_s(z, 1, s_0); /* <-, line 28 */
             if (ret < 0) return ret;
         }
         z->B[0] = 1; /* set Y_found, line 28 */
@@ -396,9 +387,10 @@ static int r_prelude(struct SN_env * z) {
             int c4 = z->c;
             while(1) { /* goto, line 29 */
                 int c5 = z->c;
-                if (in_grouping(z, g_v, 97, 121, 0)) goto lab4;
+                if (in_grouping(z, g_v, 97, 121, 0)) goto lab4; /* grouping v, line 29 */
                 z->bra = z->c; /* [, line 29 */
-                if (!(eq_s(z, 1, s_3))) goto lab4;
+                if (z->c == z->l || z->p[z->c] != 'y') goto lab4; /* literal, line 29 */
+                z->c++;
                 z->ket = z->c; /* ], line 29 */
                 z->c = c5;
                 break;
@@ -407,7 +399,7 @@ static int r_prelude(struct SN_env * z) {
                 if (z->c >= z->l) goto lab3;
                 z->c++; /* goto, line 29 */
             }
-            {   int ret = slice_from_s(z, 1, s_4); /* <-, line 29 */
+            {   int ret = slice_from_s(z, 1, s_1); /* <-, line 29 */
                 if (ret < 0) return ret;
             }
             z->B[0] = 1; /* set Y_found, line 29 */
@@ -421,13 +413,13 @@ static int r_prelude(struct SN_env * z) {
     return 1;
 }
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    z->I[1] = z->l;
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $p1 = <integer expression>, line 33 */
+    z->I[1] = z->l; /* $p2 = <integer expression>, line 34 */
     {   int c1 = z->c; /* do, line 35 */
         {   int c2 = z->c; /* or, line 41 */
-            if (z->c + 4 >= z->l || z->p[z->c + 4] >> 5 != 3 || !((2375680 >> (z->p[z->c + 4] & 0x1f)) & 1)) goto lab2;
-            if (!(find_among(z, a_0, 3))) goto lab2; /* among, line 36 */
+            if (z->c + 4 >= z->l || z->p[z->c + 4] >> 5 != 3 || !((2375680 >> (z->p[z->c + 4] & 0x1f)) & 1)) goto lab2; /* among, line 36 */
+            if (!(find_among(z, a_0, 3))) goto lab2;
             goto lab1;
         lab2:
             z->c = c2;
@@ -461,76 +453,69 @@ static int r_mark_regions(struct SN_env * z) {
     return 1;
 }
 
-static int r_shortv(struct SN_env * z) {
+static int r_shortv(struct SN_env * z) { /* backwardmode */
     {   int m1 = z->l - z->c; (void)m1; /* or, line 51 */
-        if (out_grouping_b(z, g_v_WXY, 89, 121, 0)) goto lab1;
-        if (in_grouping_b(z, g_v, 97, 121, 0)) goto lab1;
-        if (out_grouping_b(z, g_v, 97, 121, 0)) goto lab1;
+        if (out_grouping_b(z, g_v_WXY, 89, 121, 0)) goto lab1; /* non v_WXY, line 50 */
+        if (in_grouping_b(z, g_v, 97, 121, 0)) goto lab1; /* grouping v, line 50 */
+        if (out_grouping_b(z, g_v, 97, 121, 0)) goto lab1; /* non v, line 50 */
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        if (out_grouping_b(z, g_v, 97, 121, 0)) return 0;
-        if (in_grouping_b(z, g_v, 97, 121, 0)) return 0;
+        if (out_grouping_b(z, g_v, 97, 121, 0)) return 0; /* non v, line 52 */
+        if (in_grouping_b(z, g_v, 97, 121, 0)) return 0; /* grouping v, line 52 */
         if (z->c > z->lb) return 0; /* atlimit, line 52 */
     }
 lab0:
     return 1;
 }
 
-static int r_R1(struct SN_env * z) {
-    if (!(z->I[0] <= z->c)) return 0;
+static int r_R1(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[0] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 55 */
     return 1;
 }
 
-static int r_R2(struct SN_env * z) {
-    if (!(z->I[1] <= z->c)) return 0;
+static int r_R2(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[1] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 56 */
     return 1;
 }
 
-static int r_Step_1a(struct SN_env * z) {
+static int r_Step_1a(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 59 */
+    {   int m1 = z->l - z->c; (void)m1; /* try, line 59 */
         z->ket = z->c; /* [, line 60 */
-        if (z->c <= z->lb || (z->p[z->c - 1] != 39 && z->p[z->c - 1] != 115)) { z->c = z->l - m_keep; goto lab0; }
-        among_var = find_among_b(z, a_1, 3); /* substring, line 60 */
-        if (!(among_var)) { z->c = z->l - m_keep; goto lab0; }
+        if (z->c <= z->lb || (z->p[z->c - 1] != 39 && z->p[z->c - 1] != 115)) { z->c = z->l - m1; goto lab0; } /* substring, line 60 */
+        if (!(find_among_b(z, a_1, 3))) { z->c = z->l - m1; goto lab0; }
         z->bra = z->c; /* ], line 60 */
-        switch(among_var) {
-            case 0: { z->c = z->l - m_keep; goto lab0; }
-            case 1:
-                {   int ret = slice_del(z); /* delete, line 62 */
-                    if (ret < 0) return ret;
-                }
-                break;
+        {   int ret = slice_del(z); /* delete, line 62 */
+            if (ret < 0) return ret;
         }
     lab0:
         ;
     }
     z->ket = z->c; /* [, line 65 */
-    if (z->c <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 115)) return 0;
-    among_var = find_among_b(z, a_2, 6); /* substring, line 65 */
+    if (z->c <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 115)) return 0; /* substring, line 65 */
+    among_var = find_among_b(z, a_2, 6);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 65 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 65 */
         case 1:
-            {   int ret = slice_from_s(z, 2, s_5); /* <-, line 66 */
+            {   int ret = slice_from_s(z, 2, s_2); /* <-, line 66 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int m1 = z->l - z->c; (void)m1; /* or, line 68 */
-                {   int ret = z->c - 2;
+            {   int m2 = z->l - z->c; (void)m2; /* or, line 68 */
+                {   int ret = z->c - 2; /* hop, line 68 */
                     if (z->lb > ret || ret > z->l) goto lab2;
-                    z->c = ret; /* hop, line 68 */
+                    z->c = ret;
                 }
-                {   int ret = slice_from_s(z, 1, s_6); /* <-, line 68 */
+                {   int ret = slice_from_s(z, 1, s_3); /* <-, line 68 */
                     if (ret < 0) return ret;
                 }
                 goto lab1;
             lab2:
-                z->c = z->l - m1;
-                {   int ret = slice_from_s(z, 2, s_7); /* <-, line 68 */
+                z->c = z->l - m2;
+                {   int ret = slice_from_s(z, 2, s_4); /* <-, line 68 */
                     if (ret < 0) return ret;
                 }
             }
@@ -552,48 +537,47 @@ static int r_Step_1a(struct SN_env * z) {
     return 1;
 }
 
-static int r_Step_1b(struct SN_env * z) {
+static int r_Step_1b(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 75 */
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((33554576 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_4, 6); /* substring, line 75 */
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((33554576 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 75 */
+    among_var = find_among_b(z, a_4, 6);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 75 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 75 */
         case 1:
-            {   int ret = r_R1(z);
-                if (ret == 0) return 0; /* call R1, line 77 */
-                if (ret < 0) return ret;
+            {   int ret = r_R1(z); /* call R1, line 77 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 2, s_8); /* <-, line 77 */
+            {   int ret = slice_from_s(z, 2, s_5); /* <-, line 77 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int m_test = z->l - z->c; /* test, line 80 */
+            {   int m_test1 = z->l - z->c; /* test, line 80 */
                 {    /* gopast */ /* grouping v, line 80 */
                     int ret = out_grouping_b(z, g_v, 97, 121, 1);
                     if (ret < 0) return 0;
                     z->c -= ret;
                 }
-                z->c = z->l - m_test;
+                z->c = z->l - m_test1;
             }
             {   int ret = slice_del(z); /* delete, line 80 */
                 if (ret < 0) return ret;
             }
-            {   int m_test = z->l - z->c; /* test, line 81 */
-                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((68514004 >> (z->p[z->c - 1] & 0x1f)) & 1)) among_var = 3; else
-                among_var = find_among_b(z, a_3, 13); /* substring, line 81 */
+            {   int m_test2 = z->l - z->c; /* test, line 81 */
+                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((68514004 >> (z->p[z->c - 1] & 0x1f)) & 1)) among_var = 3; else /* substring, line 81 */
+                among_var = find_among_b(z, a_3, 13);
                 if (!(among_var)) return 0;
-                z->c = z->l - m_test;
+                z->c = z->l - m_test2;
             }
-            switch(among_var) {
-                case 0: return 0;
+            switch (among_var) { /* among, line 81 */
                 case 1:
-                    {   int c_keep = z->c;
-                        int ret = insert_s(z, z->c, z->c, 1, s_9); /* <+, line 83 */
-                        z->c = c_keep;
+                    {   int ret;
+                        {   int saved_c = z->c;
+                            ret = insert_s(z, z->c, z->c, 1, s_6); /* <+, line 83 */
+                            z->c = saved_c;
+                        }
                         if (ret < 0) return ret;
                     }
                     break;
@@ -608,16 +592,17 @@ static int r_Step_1b(struct SN_env * z) {
                     break;
                 case 3:
                     if (z->c != z->I[0]) return 0; /* atmark, line 87 */
-                    {   int m_test = z->l - z->c; /* test, line 87 */
-                        {   int ret = r_shortv(z);
-                            if (ret == 0) return 0; /* call shortv, line 87 */
-                            if (ret < 0) return ret;
+                    {   int m_test3 = z->l - z->c; /* test, line 87 */
+                        {   int ret = r_shortv(z); /* call shortv, line 87 */
+                            if (ret <= 0) return ret;
                         }
-                        z->c = z->l - m_test;
+                        z->c = z->l - m_test3;
                     }
-                    {   int c_keep = z->c;
-                        int ret = insert_s(z, z->c, z->c, 1, s_10); /* <+, line 87 */
-                        z->c = c_keep;
+                    {   int ret;
+                        {   int saved_c = z->c;
+                            ret = insert_s(z, z->c, z->c, 1, s_7); /* <+, line 87 */
+                            z->c = saved_c;
+                        }
                         if (ret < 0) return ret;
                     }
                     break;
@@ -627,121 +612,115 @@ static int r_Step_1b(struct SN_env * z) {
     return 1;
 }
 
-static int r_Step_1c(struct SN_env * z) {
+static int r_Step_1c(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 94 */
     {   int m1 = z->l - z->c; (void)m1; /* or, line 94 */
-        if (!(eq_s_b(z, 1, s_11))) goto lab1;
+        if (z->c <= z->lb || z->p[z->c - 1] != 'y') goto lab1; /* literal, line 94 */
+        z->c--;
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        if (!(eq_s_b(z, 1, s_12))) return 0;
+        if (z->c <= z->lb || z->p[z->c - 1] != 'Y') return 0; /* literal, line 94 */
+        z->c--;
     }
 lab0:
     z->bra = z->c; /* ], line 94 */
-    if (out_grouping_b(z, g_v, 97, 121, 0)) return 0;
-    {   int m2 = z->l - z->c; (void)m2; /* not, line 95 */
-        if (z->c > z->lb) goto lab2; /* atlimit, line 95 */
-        return 0;
-    lab2:
-        z->c = z->l - m2;
-    }
-    {   int ret = slice_from_s(z, 1, s_13); /* <-, line 96 */
+    if (out_grouping_b(z, g_v, 97, 121, 0)) return 0; /* non v, line 95 */
+    /* not, line 95 */
+    if (z->c > z->lb) goto lab2; /* atlimit, line 95 */
+    return 0;
+lab2:
+    {   int ret = slice_from_s(z, 1, s_8); /* <-, line 96 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_Step_2(struct SN_env * z) {
+static int r_Step_2(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 100 */
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((815616 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_5, 24); /* substring, line 100 */
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((815616 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 100 */
+    among_var = find_among_b(z, a_5, 24);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 100 */
-    {   int ret = r_R1(z);
-        if (ret == 0) return 0; /* call R1, line 100 */
-        if (ret < 0) return ret;
+    {   int ret = r_R1(z); /* call R1, line 100 */
+        if (ret <= 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 100 */
         case 1:
-            {   int ret = slice_from_s(z, 4, s_14); /* <-, line 101 */
+            {   int ret = slice_from_s(z, 4, s_9); /* <-, line 101 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 4, s_15); /* <-, line 102 */
+            {   int ret = slice_from_s(z, 4, s_10); /* <-, line 102 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_from_s(z, 4, s_16); /* <-, line 103 */
+            {   int ret = slice_from_s(z, 4, s_11); /* <-, line 103 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            {   int ret = slice_from_s(z, 4, s_17); /* <-, line 104 */
+            {   int ret = slice_from_s(z, 4, s_12); /* <-, line 104 */
                 if (ret < 0) return ret;
             }
             break;
         case 5:
-            {   int ret = slice_from_s(z, 3, s_18); /* <-, line 105 */
+            {   int ret = slice_from_s(z, 3, s_13); /* <-, line 105 */
                 if (ret < 0) return ret;
             }
             break;
         case 6:
-            {   int ret = slice_from_s(z, 3, s_19); /* <-, line 107 */
+            {   int ret = slice_from_s(z, 3, s_14); /* <-, line 107 */
                 if (ret < 0) return ret;
             }
             break;
         case 7:
-            {   int ret = slice_from_s(z, 3, s_20); /* <-, line 109 */
+            {   int ret = slice_from_s(z, 3, s_15); /* <-, line 109 */
                 if (ret < 0) return ret;
             }
             break;
         case 8:
-            {   int ret = slice_from_s(z, 2, s_21); /* <-, line 111 */
+            {   int ret = slice_from_s(z, 2, s_16); /* <-, line 111 */
                 if (ret < 0) return ret;
             }
             break;
         case 9:
-            {   int ret = slice_from_s(z, 3, s_22); /* <-, line 112 */
+            {   int ret = slice_from_s(z, 3, s_17); /* <-, line 112 */
                 if (ret < 0) return ret;
             }
             break;
         case 10:
-            {   int ret = slice_from_s(z, 3, s_23); /* <-, line 114 */
+            {   int ret = slice_from_s(z, 3, s_18); /* <-, line 114 */
                 if (ret < 0) return ret;
             }
             break;
         case 11:
-            {   int ret = slice_from_s(z, 3, s_24); /* <-, line 116 */
+            {   int ret = slice_from_s(z, 3, s_19); /* <-, line 116 */
                 if (ret < 0) return ret;
             }
             break;
         case 12:
-            {   int ret = slice_from_s(z, 3, s_25); /* <-, line 118 */
+            {   int ret = slice_from_s(z, 3, s_20); /* <-, line 118 */
                 if (ret < 0) return ret;
             }
             break;
         case 13:
-            if (!(eq_s_b(z, 1, s_26))) return 0;
-            {   int ret = slice_from_s(z, 2, s_27); /* <-, line 119 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'l') return 0; /* literal, line 119 */
+            z->c--;
+            {   int ret = slice_from_s(z, 2, s_21); /* <-, line 119 */
                 if (ret < 0) return ret;
             }
             break;
         case 14:
-            {   int ret = slice_from_s(z, 3, s_28); /* <-, line 120 */
+            {   int ret = slice_from_s(z, 4, s_22); /* <-, line 121 */
                 if (ret < 0) return ret;
             }
             break;
         case 15:
-            {   int ret = slice_from_s(z, 4, s_29); /* <-, line 121 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 16:
-            if (in_grouping_b(z, g_valid_LI, 99, 116, 0)) return 0;
+            if (in_grouping_b(z, g_valid_LI, 99, 116, 0)) return 0; /* grouping valid_LI, line 122 */
             {   int ret = slice_del(z); /* delete, line 122 */
                 if (ret < 0) return ret;
             }
@@ -750,36 +729,34 @@ static int r_Step_2(struct SN_env * z) {
     return 1;
 }
 
-static int r_Step_3(struct SN_env * z) {
+static int r_Step_3(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 127 */
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((528928 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_6, 9); /* substring, line 127 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((528928 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 127 */
+    among_var = find_among_b(z, a_6, 9);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 127 */
-    {   int ret = r_R1(z);
-        if (ret == 0) return 0; /* call R1, line 127 */
-        if (ret < 0) return ret;
+    {   int ret = r_R1(z); /* call R1, line 127 */
+        if (ret <= 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 127 */
         case 1:
-            {   int ret = slice_from_s(z, 4, s_30); /* <-, line 128 */
+            {   int ret = slice_from_s(z, 4, s_23); /* <-, line 128 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 3, s_31); /* <-, line 129 */
+            {   int ret = slice_from_s(z, 3, s_24); /* <-, line 129 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_from_s(z, 2, s_32); /* <-, line 130 */
+            {   int ret = slice_from_s(z, 2, s_25); /* <-, line 130 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            {   int ret = slice_from_s(z, 2, s_33); /* <-, line 132 */
+            {   int ret = slice_from_s(z, 2, s_26); /* <-, line 132 */
                 if (ret < 0) return ret;
             }
             break;
@@ -789,9 +766,8 @@ static int r_Step_3(struct SN_env * z) {
             }
             break;
         case 6:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 136 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 136 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 136 */
                 if (ret < 0) return ret;
@@ -801,19 +777,17 @@ static int r_Step_3(struct SN_env * z) {
     return 1;
 }
 
-static int r_Step_4(struct SN_env * z) {
+static int r_Step_4(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 141 */
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1864232 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_7, 18); /* substring, line 141 */
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1864232 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 141 */
+    among_var = find_among_b(z, a_7, 18);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 141 */
-    {   int ret = r_R2(z);
-        if (ret == 0) return 0; /* call R2, line 141 */
-        if (ret < 0) return ret;
+    {   int ret = r_R2(z); /* call R2, line 141 */
+        if (ret <= 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 141 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 144 */
                 if (ret < 0) return ret;
@@ -821,11 +795,13 @@ static int r_Step_4(struct SN_env * z) {
             break;
         case 2:
             {   int m1 = z->l - z->c; (void)m1; /* or, line 145 */
-                if (!(eq_s_b(z, 1, s_34))) goto lab1;
+                if (z->c <= z->lb || z->p[z->c - 1] != 's') goto lab1; /* literal, line 145 */
+                z->c--;
                 goto lab0;
             lab1:
                 z->c = z->l - m1;
-                if (!(eq_s_b(z, 1, s_35))) return 0;
+                if (z->c <= z->lb || z->p[z->c - 1] != 't') return 0; /* literal, line 145 */
+                z->c--;
             }
         lab0:
             {   int ret = slice_del(z); /* delete, line 145 */
@@ -836,31 +812,29 @@ static int r_Step_4(struct SN_env * z) {
     return 1;
 }
 
-static int r_Step_5(struct SN_env * z) {
+static int r_Step_5(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 150 */
-    if (z->c <= z->lb || (z->p[z->c - 1] != 101 && z->p[z->c - 1] != 108)) return 0;
-    among_var = find_among_b(z, a_8, 2); /* substring, line 150 */
+    if (z->c <= z->lb || (z->p[z->c - 1] != 101 && z->p[z->c - 1] != 108)) return 0; /* substring, line 150 */
+    among_var = find_among_b(z, a_8, 2);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 150 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 150 */
         case 1:
             {   int m1 = z->l - z->c; (void)m1; /* or, line 151 */
-                {   int ret = r_R2(z);
-                    if (ret == 0) goto lab1; /* call R2, line 151 */
+                {   int ret = r_R2(z); /* call R2, line 151 */
+                    if (ret == 0) goto lab1;
                     if (ret < 0) return ret;
                 }
                 goto lab0;
             lab1:
                 z->c = z->l - m1;
-                {   int ret = r_R1(z);
-                    if (ret == 0) return 0; /* call R1, line 151 */
-                    if (ret < 0) return ret;
+                {   int ret = r_R1(z); /* call R1, line 151 */
+                    if (ret <= 0) return ret;
                 }
                 {   int m2 = z->l - z->c; (void)m2; /* not, line 151 */
-                    {   int ret = r_shortv(z);
-                        if (ret == 0) goto lab2; /* call shortv, line 151 */
+                    {   int ret = r_shortv(z); /* call shortv, line 151 */
+                        if (ret == 0) goto lab2;
                         if (ret < 0) return ret;
                     }
                     return 0;
@@ -874,11 +848,11 @@ static int r_Step_5(struct SN_env * z) {
             }
             break;
         case 2:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 152 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 152 */
+                if (ret <= 0) return ret;
             }
-            if (!(eq_s_b(z, 1, s_36))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'l') return 0; /* literal, line 152 */
+            z->c--;
             {   int ret = slice_del(z); /* delete, line 152 */
                 if (ret < 0) return ret;
             }
